trait Trait {
    type More: ?Sized + Trait;
}

trait ImplBase<T: ?Sized + Trait> {
    type More: ?Sized + ImplSelf<T::More>;
}

trait ImplSelf<T: ?Sized + Trait>: ImplBase<T, More = Self> {}

impl<T: ?Sized + Trait, I: ?Sized + ImplBase<T, More = I>> ImplSelf<T> for I {}

struct Empty;

impl Trait for Empty {
    type More = Self;
}

impl<T: ?Sized> ImplBase<Empty> for T {
    type More = Self;
}

fn test() -> impl ImplSelf<Empty> {
    123
}

pub fn _test() {
    let _ = test();
}
